// Code generated by genpjrpc. DO NOT EDIT.
//  genpjrpc version: v0.0.1-go_test

package server

import (
	"context"
	"encoding/json"
	"fmt"

	pjrpc "gitlab.com/pjrpc/pjrpc/v2"
	"gitlab.com/pjrpc/pjrpc/v2/pjson"

	"gitlab.com/repo/project/pkg/service/model"
)

// List of the server JSON-RPC methods.
const (
	JSONRPCMethodServiceSomeWork        = "service_some_work"
	JSONRPCMethodServiceNotPointerTypes = "service_not_pointer_types"
	JSONRPCMethodServiceDictionaryMap   = "service_dictionary_map"
)

// ServiceServer is an API server for Service service.
type ServiceServer interface {
	// SomeWork comments of the method.
	// Second line.
	//
	// Deprecated: Do not use.
	SomeWork(ctx context.Context, in *model.In) (*model.Out, error)
	NotPointerTypes(ctx context.Context, in model.BasicType) (model.SliceType, error)
	DictionaryMap(ctx context.Context, in model.Dictionary) (*model.StructWithDictionary, error)
}

type regService struct {
	svc ServiceServer
}

// RegisterServiceServer registers rpc handlers with middlewares in the server router.
func RegisterServiceServer(srv pjrpc.Registrator, svc ServiceServer, middlewares ...pjrpc.Middleware) {
	r := &regService{svc: svc}

	srv.RegisterMethod(JSONRPCMethodServiceSomeWork, r.regSomeWork)
	srv.RegisterMethod(JSONRPCMethodServiceNotPointerTypes, r.regNotPointerTypes)
	srv.RegisterMethod(JSONRPCMethodServiceDictionaryMap, r.regDictionaryMap)

	srv.With(middlewares...)
}

func (r *regService) regSomeWork(ctx context.Context, params json.RawMessage) (interface{}, error) {
	in := new(model.In)
	if params != nil {
		if err := pjson.Unmarshal(params, in); err != nil {
			return nil, pjrpc.JRPCErrParseError("failed to parse params")
		}
	}

	res, err := r.svc.SomeWork(ctx, in)
	if err != nil {
		return nil, fmt.Errorf("failed SomeWork: %w", err)
	}

	return res, nil
}

func (r *regService) regNotPointerTypes(ctx context.Context, params json.RawMessage) (interface{}, error) {
	var in model.BasicType
	if params != nil {
		if err := pjson.Unmarshal(params, &in); err != nil {
			return nil, pjrpc.JRPCErrParseError("failed to parse params")
		}
	}

	res, err := r.svc.NotPointerTypes(ctx, in)
	if err != nil {
		return nil, fmt.Errorf("failed NotPointerTypes: %w", err)
	}

	return res, nil
}

func (r *regService) regDictionaryMap(ctx context.Context, params json.RawMessage) (interface{}, error) {
	var in model.Dictionary
	if params != nil {
		if err := pjson.Unmarshal(params, &in); err != nil {
			return nil, pjrpc.JRPCErrParseError("failed to parse params")
		}
	}

	res, err := r.svc.DictionaryMap(ctx, in)
	if err != nil {
		return nil, fmt.Errorf("failed DictionaryMap: %w", err)
	}

	return res, nil
}
